      subroutine gaupod(istat,coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (numat1=20000)
      parameter (maxfat=1000)
      parameter (numatm=2000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat

      common /gxyz/ ixyz98,iopr
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      character lstr*137
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*23 stmp
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor
      dimension itemp(numat1),ctemp(3,numat1)
      dimension coo(3,*),ianz(*)

      toang = 0.52917706d0
      ig98 = 0
      stmp = 'Input orientation:'
      ns = 18
      if (ixyz98.gt.0.and.(ioropt.eq.2)) then
          stmp = 'Standard orientation:'
          ns = 22
      endif

c     istat = 0     no Z-Matrix orientation found
c     istat = -1    no Cartesian Forces found
c     istat = ge 1  both Standard orientation and forces found

c
c     Gaussian forces are in the Z-matrix orientation (not in standard)
c
      if (nzm.eq.nzo.and.nzm.gt.0) then
         call search(lstr,'Z-MATRIX (ANGSTROMS',istat)
      elseif (nzo.gt.0) then
         call search(lstr,'Z-Matrix orientation:',istat)
      else
         call search(lstr,stmp(1:ns),istat)
      endif

      if (istat.eq.0 ) return
      if (index(lstr,'Z-MATRIX (ANGSTROMS').eq.0) then
         call haszm(.false.)
         backspace iun2
      else
         call readel(lstr,2)
         call convzmat(coo,ianz,iatoms,.true.,.false.)
      endif

      call searchd(lstr,'Z-Matrix orientation:',stmp(1:ns),istat)
      if (istat.eq.0) then
         return
      else
         call readel(lstr,2)
         read(iun2,'(a)',err=100) lstr
         if (icdex(lstr,'Type').ne.0) ig98 = 1
         call readel(lstr,1)
      endif

      nz = 0
      do while ( .true. )
         read(iun2,'(a)',err=100) lstr
         if ( lstr(2:4) .eq. '---' ) goto 10
         nz = nz + 1
         if (ig98.eq.1) then
            read(lstr,'(12x,i4,18x,3(f12.6))',err=100) itemp(nz),
     &       (ctemp(j,nz),j=1,3)
         else
            read(lstr,'(12x,i4,7x,3(f12.6))',err=100) itemp(nz),
     &       (ctemp(j,nz),j=1,3)
         endif
      end do
10    continue

c get rid off dummy atoms

      iatoms = 0
      do 400 i=1,nz
         if(itemp(i))400,500,500
500      iatoms = iatoms + 1
         ianz(iatoms) = itemp(i)
         do j=1,3
            coo(j,iatoms) = ctemp(j,i)
         end do
400   continue 

      do i=1,iatoms
c         print*,'coo ',i,(coo(j,i),j=1,3)
         do j=1,3
             coo(j,i) = coo(j,i)/toang
         end do
      end do

c gaussian 98 doesnt do more than 50 atoms forces print

c      if (ixyz98.gt.0.and.iatoms.gt.50.and.iopr.eq.0) goto 100

      if ((nzm.eq.nzo.and.nzm.gt.0).or.nzo.gt.0) then
         call searcht(lstr,'Forces (Hartrees/Bohr)',
     &   'Z-MATRIX (ANGSTROMS',
     &   'Z-Matrix orientation:',istat)
      else
         call searchd(lstr,'Forces (Hartrees/Bohr)',
     &   stmp(1:ns),istat)
      endif

      if (istat.eq.0) goto 200
      if (icdex(lstr,'Forces (Hartrees/Bohr)').eq.0) then
           istat = -1
           backspace iun2
           return
      endif
      call readel(lstr,2)
      do i=1,iatoms
         read(iun2,'(23x,3(f15.9))',err=200)(fxyz(j,i),j=1,3)
c         print*,(fxyz(j,i),j=1,3)
      end do

      return

100   istat = 0
      return
200   istat =-1 
      return
      end
